Bug 114484 - Make internal file and print dialogs obsolete
Summary: Make internal file and print dialogs obsolete
Status: NEW
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: UI (show other bugs)
Version:
(earliest affected)
unspecified
Hardware: All All
: medium normal
Assignee: Not Assigned
URL: https://lists.freedesktop.org/archive...
Whiteboard: target:6.1.0 target:6.0.0.1
Keywords:
Depends on:
Blocks: 34303 LO-File-Dialog Print-Dialog
  Show dependency treegraph
 
Reported: 2017-12-15 09:22 UTC by Heiko Tietze
Modified: 2018-10-08 13:36 UTC (History)
9 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Heiko Tietze 2017-12-15 09:22:58 UTC
Recommended in [1] and accepted in [2] the task is to remove the internal file and print dialogs because of 
* bug 87860 the concept of self-made file-picker is not working well and requires much additional work for no good reason, 
* kde4 replacement is not needed anymore – will have Qt5 dialog, and 
* CMIS dialogs for access to remote servers are implemented now.

The gen backend might get removed too (but needs the dialogs for now).

[1] http://nabble.documentfoundation.org/Libreoffice-qa-minutes-of-ESC-call-tt4229118.html
[2] http://nabble.documentfoundation.org/Re-Agenda-for-the-design-UX-meeting-2017-Dec-13-tt4229075.html
Comment 1 Commit Notification 2017-12-15 13:04:01 UTC
heiko tietze committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=65ee299a0c0e9044d809e58c3c5e75d05ad76f0e

tdf#114484 - Make internal file and print dialogs obsolete

It will be available in 6.1.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 2 Heiko Tietze 2017-12-15 15:18:15 UTC
Simple access vi UI is hidden with the patch, Tools > Options > Advanced > Expert > org.openoffice.Office.Common.Misc > UseSystemFileDialog can still be used to enable or disable. Regardless this option the internal dialogs will also be shown for SAL_USE_VCLPLUGIN=gen and are relevant for headless mode.

Some code pointers to clean up later (would keep the ticket open):
svtools/source/config/miscopt.cxx
include/svtools/miscopt.hxx
cui/source/options/optgdlg.cxx
cui/source/options/optgdlg.hxx
desktop/source/app/app.cxx
svtools/source/uno/fpicker.cxx

The internal print dialog is still enabled, however the respective field is hidden with code.

OfaMiscTabPage::OfaMiscTabPage(vcl::Window* pParent, const SfxItemSet& rSet)
    : SfxTabPage(pParent, "OptGeneralPage", "cui/ui/optgeneralpage.ui", &rSet)
{
    get(m_pExtHelpCB, "exthelp");
    if (!lcl_HasSystemFilePicker())
        get<VclContainer>("filedlgframe")->Hide();
#if ! ENABLE_GTK
    get<VclContainer>("printdlgframe")->Hide();
#else
    if (!SvtMiscOptions().IsExperimentalMode())
    {
        get<VclContainer>("printdlgframe")->Hide();
    }
#endif
Comment 3 Yousuf Philips (jay) (retired) 2017-12-15 21:53:35 UTC
(In reply to Heiko Tietze from comment #0)
> Recommended in [1] and accepted in [2] the task is to remove the internal
> file and print dialogs because of 

There was no talk about removing the internal print dialog during the design meeting, or am i missing something.
Comment 4 Commit Notification 2017-12-15 23:04:41 UTC
heiko tietze committed a patch related to this issue.
It has been pushed to "libreoffice-6-0":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=bd260a59cfdd050db3aa9a641ef0fa09efcedf5b&h=libreoffice-6-0

tdf#114484 - Make internal file and print dialogs obsolete

It will be available in 6.0.0.1.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 5 Heiko Tietze 2017-12-16 10:00:40 UTC
(In reply to Yousuf Philips (jay) from comment #3)
> There was no talk about removing the internal print dialog during the design
> meeting, or am i missing something.

Well, it's the same topic. But you are right, we didn't discuss and nothing has changed for the print dialog.
Comment 6 Julien Nabet 2017-12-16 15:05:49 UTC Comment hidden (obsolete)
Comment 7 Heiko Tietze 2017-12-16 16:03:17 UTC
(In reply to Julien Nabet from comment #6)
> Heiko since a bugtracker at status ASSIGNED requires an assignee, having
> seen your patch I put you.
> Of course don't hesitate to revert if disagree.

Forgot to set back to NEW. Reverted intentionally since the next step before 6.1 or later might need more expertise than mine. And it's up to QA whether the ticket should stay open or not as the UI access is disabled now.
Comment 8 Rene Engelhard 2017-12-16 18:38:48 UTC
Hmm. I am bit torn about this issue

I agree that these dialogs should be ideally not used. Normal desktop integration will use system file dialogs. But what about print? Do we use the KDE print dialog?

Anyways, Heiko tells me on IRC that the plan is also to remove the internal code for these. There os where problems begin:

There is cases where you don't have the needed stuff:
 - nothing for kde5
 - file pickers disabled for kde4 at runtime with non-patched Qt4
 - gtk2 and gtk3 can both be disabled. Also can be in own packages.

So you might not have *any* of those. What are you then going to use?
Of course, one could inflict a gtk3 dependency here, but is it worth it? And will
LO then have a hard gtk3 dependency when people use a (prospective) gtk4 VCLPlug?
Comment 9 Maxim Monastirsky 2017-12-16 20:19:46 UTC
Enabling the system print dialog is currently an experimental feature, as it lacks some features [1], and it isn't available anywhere outside gtk2/gtk3. So removing it isn't an option.

[1] https://lists.freedesktop.org/archives/libreoffice/2017-April/077625.html
Comment 10 Heiko Tietze 2017-12-16 20:36:02 UTC
Don't see a difference when I check the internal print dialog option or not (using "gen" VCL). Bad usability, btw, to completely hide options - both internal dialogs are hidden depending on the setup.

Haven't counted the tickets at bug 103309 but there are a lot. At least for the internal file dialog I don't see progress to make them work. And for what reason? So my take is, after all Rene's concerns and since headless and gen use the internal file dialogs, that we strip down any additional functionality and dont even try to make them competitive with the system picker. Only the most important stuff should be kept.
Comment 11 Yousuf Philips (jay) (retired) 2017-12-19 19:40:18 UTC
(In reply to Heiko Tietze from comment #10)
> ... At least for
> the internal file dialog I don't see progress to make them work. And for
> what reason? So my take is, after all Rene's concerns and since headless and
> gen use the internal file dialogs, that we strip down any additional
> functionality and dont even try to make them competitive with the system
> picker. Only the most important stuff should be kept.

+1
Comment 12 Timur 2018-10-08 13:36:40 UTC
This bug is marked All but from what I see discussion was chiefly about Linux. 
I may be off-topic with this, but let me bump this bug saying this:
In Windows 7 I have a folder with 5624 documents (surprise: it's LO bug docs).
LO is unable to sort this amount of files (by Date or by Name) from within File-Open dialog (shown with Details). 
Can't say why, but Save dialog works fine.